local ____lualib = require("lualib_bundle")
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____ModCallbackCustom = require("enums.ModCallbackCustom")
local ModCallbackCustom = ____ModCallbackCustom.ModCallbackCustom
local ____playerDataStructures = require("functions.playerDataStructures")
local setAddPlayer = ____playerDataStructures.setAddPlayer
local setHasPlayer = ____playerDataStructures.setHasPlayer
local ____shouldFire = require("shouldFire")
local shouldFirePlayer = ____shouldFire.shouldFirePlayer
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
local v = {run = {playersFiredSet = __TS__New(Set)}}
____exports.PostPlayerInitLate = __TS__Class()
local PostPlayerInitLate = ____exports.PostPlayerInitLate
PostPlayerInitLate.name = "PostPlayerInitLate"
__TS__ClassExtends(PostPlayerInitLate, CustomCallback)
function PostPlayerInitLate.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.v = v
    self.shouldFire = shouldFirePlayer
    self.postPEffectUpdateReordered = function(____, player)
        if not setHasPlayer(nil, v.run.playersFiredSet, player) then
            setAddPlayer(nil, v.run.playersFiredSet, player)
            self:fire(player)
        end
    end
    self.customCallbacksUsed = {{ModCallbackCustom.POST_PEFFECT_UPDATE_REORDERED, self.postPEffectUpdateReordered}}
end
return ____exports
